# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was openenclave-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# Reference data.
set(OE_BRANCH "refs/heads/v0.5.x")
set(OE_COMMIT "26eed5efdeaa200e9ee084ec0aa45ecc7d82aaf1")
set(OE_BUILD_NUMBER "12")

set_and_check(OE_LIBDIR "${PACKAGE_PREFIX_DIR}/lib")
set_and_check(OE_BINDIR "${PACKAGE_PREFIX_DIR}/bin")
set_and_check(OE_DATADIR "${PACKAGE_PREFIX_DIR}/share")
set_and_check(OE_INCLUDEDIR "${PACKAGE_PREFIX_DIR}/include")

# Check for compiler flags
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

# Dependencies.
include(CMakeFindDependencyMacro)
find_dependency(Threads)

# This target is an OCaml executable, not C++, so we have to manually
# "export" it here for users of the package.
add_executable(openenclave::oeedger8r IMPORTED)
set_target_properties(openenclave::oeedger8r PROPERTIES IMPORTED_LOCATION ${OE_BINDIR}/oeedger8r)

# Include the automatically exported targets.
include("${CMAKE_CURRENT_LIST_DIR}/openenclave-targets.cmake")

# Apply Spectre mitigations if available.
set(OE_SPECTRE_MITIGATION_FLAGS "-mllvm;-x86-speculative-load-hardening")
check_c_compiler_flag("${OE_SPECTRE_MITIGATION_FLAGS}" OE_SPECTRE_MITIGATION_C_FLAGS_SUPPORTED)
check_cxx_compiler_flag("${OE_SPECTRE_MITIGATION_FLAGS}" OE_SPECTRE_MITIGATION_CXX_FLAGS_SUPPORTED)
if (OE_SPECTRE_MITIGATION_C_FLAGS_SUPPORTED AND OE_SPECTRE_MITIGATION_CXX_FLAGS_SUPPORTED)
  target_compile_options(openenclave::oecore INTERFACE ${OE_SPECTRE_MITIGATION_FLAGS})
endif ()
